#
# frame.py
#
#
# Definition of frame class
#
# 1.8.2005 Mazany Ondrej - email:mazany.o@seznam.cz
#
# This class holds information about frame, which objects are animated in the frame
#

# include object class
from animobject import *

class Frame:
    "A Frame class which is used by animator project for frames configuration"
    def __init__(self):
        self.n = 0                                   # number of frame
        self.animobjects = list()                    # list of objects modified in this frame        
    def setUp(self): # configures data in this frame
        "Sets this frame up"
        try:
            import Blender
            if self.n <> 0: # check for incorrect data
                Blender.Set( 'curframe', self.n) # set the current frame in Blender            
            for obj in self.animobjects: # for all objects animated in this frame
                obj.setUp() # set the object up
            print "Frame",self.n,"set up correctly."
        except:
            print "!! Problem setting ", self.n," frame !!"
