# Cesta k souborum
import sys
sys.path.append("c:\\Diplomka\Python")

# Texturize Interface
from Blender import *
from Blender import Draw
from Blender import Image
from Blender import NMesh
from Blender.Object import *
from Blender.Mathutils import *
from rahat.calibim import *
from rahat.poly import *
from rahat.renderobj import *
from rahat.camera import *
from rahat.parsecam import *
from rahat.glrender import *
from rahat.textures import *

# Globalni promenne
global matrixfile
global imagefile
global loadstatus
global renderdata
global CI
renderdata = None
CI = None
matrixfile = "c:\\Diplomka\\Matlab\\test.P"
imagefile = "c:\\Diplomka\\Images\\test.jpg"
loadstatus = "..."

# Vybrani souboru obrazku
def imselect_evt(filename):
    global imagefile
    imagefile  = filename
    print filename
    return

# Vybrani souboru matice
def filselect_evt(filename):
    global matrixfile 
    matrixfile = filename
    print filename
    return

# Vykresleni GUI
def gui():
    Draw.PushButton("Choose image", 1, 0, 0, 100, 20, "Vybere obrazek pro mapovani textury")
    Draw.PushButton("Choose P matrix",2,0,22,100,20,"Vybere projekcni matici k obrku")
    Draw.PushButton("Load",3,0,44,100,20,"Nacte vybrana data")
    Draw.PushButton("Render object",4,0,66,100,20,"Vykresli vybrany objekt do matice")
    Draw.PushButton("Render data to image",5,0,88,100,20,"Vykresli vybrany objekt do matice")
    Draw.PushButton("Export Camera P matrix",6,0,110,100,20,"Zapise projektivni matici do souboru")
    Draw.PushButton("Render Face",7,0,132,100,20,"Vyrenderuje momentalni face")
    Draw.PushButton("Render OpenGL",8,0,154,100,20,"OpenGL render vybranych objektu")
    Draw.PushButton("GL Depth buffer",9,110,0,100,20,"vrati depth buffer jako obrazek")
    Draw.PushButton("Test visible faces",10,110,22,100,20,"Testovaci tlacitko viditelnych polygonu")
    Draw.PushButton("OpenGL Feedback",11,110,44,100,20,"Vypise OpenGL Feedback")
    Draw.PushButton("TestGL",12,110,66,100,20,"Zobrazi dva trojuhelniky a ctverec")
    Draw.PushButton("Render Own View",13,110,88,100,20,"Zobrazi dva trojuhelniky a ctverec")
    Draw.PushButton("Load&Render",14,110,110,100,20,"Nacte kameru P a zobrazi")
    BGL.glRasterPos2i(225, 44)
    Draw.Text(loadstatus)
    BGL.glRasterPos2i(225, 22)
    Draw.Text(matrixfile)
    BGL.glRasterPos2i(225, 2)
    Draw.Text(imagefile)
    return

# Nacteni dat
def load():
    global CI
    CI = CalibIm(imagefile,matrixfile)
    CI.toTexture()
    global loadstatus
    loadstatus = "OK."

# Renderovani
def rend():
    global renderdata
    global CI
    objects = Object.GetSelected()
    for o in objects:
        if o.getType() == "Mesh":
            renderdata = renderObj( o, CI.P, CI.im.size[0], CI.im.size[1])

# Prevedeni Render data na obrazek
def rDataToIm():
    global CI
    global renderdata
    #print "renderdata:"
    #print renderdata
    CI.im = matToImage(renderdata)

# Vyexportuje P matici do souboru    
def exportP():
    objects = Object.GetSelected()
    cameras = list()
    for o in objects:
        if o.getType() == "Camera":
            cameras.append(Camera(o))
    path=Blender.Draw.PupStrInput("Path:", "c:\\Diplomka\\Data\\", 100)
    writePcalMatrices(path,cameras)
            
def faceRender():
    global renderdata
    global CI    
    i=1
    objects = Object.GetSelected()
    for o in objects:
        if o.getType() == "Mesh":   
            mesh = o.getData()
            faces = mesh.faces.selected()
            for f in faces:
                draw3DPoly( f.v, CI.P, renderdata, i)
                i=i+1

# Udalosti tlacitek    
def button_evt(event):
    if (event == 1):
        print "Vybirani obrazku:"
        Window.ImageSelector(imselect_evt,"Vyber obrazek")        
    if (event == 2):
        print "Vybirani matice P:"
        Window.FileSelector(filselect_evt,"Vyber matici P")    
    if (event == 3):
        print "Nacteni"
        load()
    if (event == 4):
        print "Renderovani"
        rend()
    if (event == 5):
        print "Prevadeni"
        rDataToIm()
    if (event == 6):
        print "P export"
        exportP()
    if (event == 7):
        print "Render Face"
        faceRender()
    if (event == 8):
        print "Render button"
        renderButton()
    if (event == 9):
        print "Depth button"
        depthButton()
    if (event == 10):
        print "Visible button"
        visibleButton()
    if (event == 11):
        print "Feedback button"
        feedbackButton()
    if (event == 12):
        print "TestGL button"
        testGLButton()
    if (event == 13):
        print "OwnView button"
        ownviewButton()
    if (event == 14):
        print "Load&Render button"
        LoadRenderButton()
    #Draw.Redraw(1)       
    return

# load and render tlacitko
def LoadRenderButton():
    load()
    initRender()
    print "Camera matrix"
    print CI.getPMatrix()
    setProjection(  CI.getPMatrix(), 
                    CI.getImage().size[0], 
                    CI.getImage().size[1])
    print "Image size:",CI.getImage().size
    for object in GetSelected():
        indexRender(object,
                    CI.getPMatrix(), 
                    CI.getImage().size[0], 
                    CI.getImage().size[1])   
    getRenderData(CI.getImage().size[0],CI.getImage().size[1])
    printMatrices()
    

# render tlacitko
def renderButton():
    initRender()
    #initView(45,0.01,10.0,640,480,[0.1,0.1,0.0],[10,0.0,0.0,1.0])
    setProjection(  CI.getPMatrix(), 
                    CI.getImage().size[0], 
                    CI.getImage().size[1])
                    #0.01,50.0) # closest object can be 0.01m, farest 50m
    print "Image size:",CI.getImage().size
    for object in GetSelected():
        renderObject(object)   
    getRenderData(CI.getImage().size[0],CI.getImage().size[1])
    return

# ownview tlacitko
def ownviewButton():
    initRender()
    #initView(45,0.01,10.0,CI.getImage().size[0],CI.getImage().size[1],[0.1,0.1,0.0],[10,0.0,0.0,1.0])
    testGLView(CI.getImage().size[0], CI.getImage().size[1])
    print "Image size:",CI.getImage().size
    for object in GetSelected():
        indexRender(object)   
    getRenderData(CI.getImage().size[0],CI.getImage().size[1])
    return

# testGL tlacitko
def testGLButton():
    initRender()
    #setProjection(  CI.getPMatrix(), 
    #                CI.getImage().size[0], 
    #                CI.getImage().size[1])
    #testGLView(CI.getImage().size[0], CI.getImage().size[1])
    testGL()
    getRenderData(800,600)
    return

# feedback tlacitko
def feedbackButton():
    initRender()
    #initView(45,0.01,10.0,640,480,[0.1,0.1,0.0],[10,0.0,0.0,1.0])
    buffer = initFeedback()
    setProjection(  CI.getPMatrix(), 
                    CI.getImage().size[0], 
                    CI.getImage().size[1])#,
                    #0.01,50.0) # closest object can be 0.01m, farest 50m
    for object in GetSelected():
        passThroughRender(object)   
    printFeedback( buffer)
    return

# depth tlacitko
def depthButton():
    initRender()
    #initView(45,0.01,10.0,640,480,[0.1,0.1,0.0],[10,0.0,0.0,1.0])
    setProjection(  CI.getPMatrix(), 
                    CI.getImage().size[0], 
                    CI.getImage().size[1],
                    0.01,50.0) # closest object can be 0.01m, farest 50m    
    for object in GetSelected():
        renderObject(object)      
    getDepthData(CI.getImage().size[0],CI.getImage().size[1])
    return

# visible tlacitko
def visibleButton():
    initRender()
    #initView(45,0.01,10.0,640,480,[0.1,0.1,0.0],[10,0.0,0.0,1.0])
    setProjection(  CI.getPMatrix(), 
                    CI.getImage().size[0], 
                    CI.getImage().size[1],
                    0.01,50.0) # closest object can be 0.01m, farest 50m
    for object in GetSelected():
        indexRender(object)  
        uv = getUV( object)
    #zbuffer=getDepthData(640,480)
    colorBuffer=getRenderData(CI.getImage().size[0],CI.getImage().size[1])
    buffer=initFeedback()
    for object in GetSelected():
        passThroughRender(object)   
    visf = getVisibleFaces(buffer,colorBuffer)
    getRenderData(CI.getImage().size[0],CI.getImage().size[1])
    print "Visible faces: ",visf
    for object in GetSelected():
        nmesh = object.getData()
        for f in nmesh.faces:
            f.sel = 0
        for f in visf:   
            index = f[0]
            if ((float(f[1])/float((f[1]+f[2]))) > 0.95) :
                print index,"visible:",(float(f[1])/float((f[1]+f[2])))    
                nmesh.faces[index].flag = NMesh.FaceFlags['SELECT']
                nmesh.faces[index].sel = 1
        nmesh.update()
    return

# Udalosti od GUI
def event(event,val):    
    #Draw.Redraw(1)
    return

# Registrace GUI v systemu
Draw.Register(gui,event,button_evt)